Graphics 1280, 800, 16, 2
SetBuffer BackBuffer()
ClsColor 20,20,20

Type waypoint
	Field id
	Field image
	Field x, y
End Type 

Global waypointimage=LoadImage("waypoint.bmp")
MaskImage waypointimage, 255, 0, 255
MidHandle(waypointimage)


Type lampe
	Field image
	Field x, y 
	Field status
End Type 

Global lampeimage=LoadImage("lampe.png")
MaskImage lampeimage, 255, 0, 255
MidHandle(Lampeimage)

Type enemy
	Field image 
	Field startx, starty
	Field zielx, ziely
	Field speed
End Type

Global enemyimage=LoadImage("enemy.png")
MaskImage enemyimage, 255, 0, 255
MidHandle (enemyimage)
	

;Nur eine Spielfigur--> keine Types(spart Zeit ;) )
Global Spielerx, Spielery, Spielerimage=LoadImage("prisoner.bmp")
MaskImage Spielerimage, 255, 0, 255
MidHandle(Spielerimage)

Dim objekte(4)

objekte(0)=spielerimage
objekte(1)=lampeimage
objekte(2)=waypointimage
objekte(3)=enemyimage

;einige Variablen
Global aktuellerwaypoint=1
Global choosenimage


While Not(KeyDown(1))
Cls 
	drawobjectbar()
	drawobjects()
	chooseobject()
	save()
	clear()
	
	

Flip(0)
Wend
End 


Function drawobjectbar()
	mh=MouseHit(1)
	For i=0 To 3
		Local objektx= 250*(i+1)
		Local objekty= 75
		
		DrawImage objekte(i), objektx, objekty
		If MouseX()>objektx-30 And MouseX()<objektx+80 And MouseY()>objekty-20 And MouseY()<objekty+80 Then
			If mh Then 
				choosenimage=objekte(i)
			EndIf 
		EndIf
	Next
	Line 0, 150, 1280, 150 
End Function 

Function chooseobject()

	Local mx=MouseX(), my=MouseY()

	If choosenimage<>0 Then 
		If my<150
			drawobjectbar()
		Else 
			DrawImage choosenimage, mx, my
		
			If MouseHit(1) And my>150 Then 
				Select choosenimage 
					Case spielerimage
						spielerx=mx
						spielery=my
					Case lampeimage
						l.lampe=New lampe
						l\image=lampeimage
						l\x=mx
						l\y=my
						l\status=0
					Case waypointimage
						w.waypoint=New waypoint
						w\image=waypointimage
						w\x=mx
						w\y=my
					Case enemyimage 
						e.enemy=New enemy
						e\image=enemyimage
						e\startx=mx
						e\starty=my
						
						While Not(MouseHit(1))	 
							Cls 
							drawobjectbar()
							
							DrawImage waypointimage, MouseX(), MouseY()
							Flip(0)
						Wend 
							e\zielx=MouseX()
							e\ziely=MouseY()
						e\speed=1
				End Select
		EndIf 	
		
		EndIf 
	EndIf 

End Function 

Function drawobjects()
	
		For w.waypoint= Each waypoint
			DrawImage w\image, w\x, w\y
		Next 
	
		For l.lampe= Each lampe
			DrawImage l\image, l\x, l\y
		Next
	
		For e.enemy= Each enemy 
			DrawImage e\image, e\startx, e\starty
			Line e\startx, e\starty, e\zielx, e\ziely
			DrawImage waypointimage,  e\zielx, e\ziely
		Next 
		
		If spielerx<>0
			DrawImage spielerimage, spielerx, spielery
		EndIf 
End Function 

Function save()
	If KeyDown(31) Then 
		Cls
		Flip(0)
		Text 0, 0, "Gib einen Namen fr dieses Level ein:"
		name$=Input()
				
		filein=WriteFile("Editor/"+name)
		
		WriteLine(filein, "Spielfigur")
		WriteLine(filein, spielerx)
		WriteLine(filein, spielery)
		
		For l.lampe= Each lampe
			WriteLine(filein, "Lampe")
			WriteLine(filein, l\x)
			WriteLine(filein, l\y)
			WriteLine(filein, l\status)
		Next 
		
		For w.waypoint= Each waypoint
			WriteLine(filein, "Waypoint")
			WriteLine(filein, w\x)
			WriteLine(filein, w\y)
		Next
		
		For e.enemy= Each enemy 
			WriteLine (filein, "Enemy")
			WriteLine (filein, e\startx)
			WriteLine (filein, e\starty)
			WriteLine (filein, e\zielx)
			WriteLine (filein, e\ziely)
			WriteLine (filein, e\speed)
		Next
		CloseFile(filein)
	EndIf 
	
	
End Function  




Function clear()
	If KeyHit(32) Then 
		For w.waypoint= Each waypoint
			Delete w.waypoint
		Next 
		
		For e.enemy=Each enemy
			Delete e.enemy
		Next
	
		For l.lampe=Each lampe
			Delete l.lampe
		Next 
		
		spielerx=0
	EndIf 
End Function 





