Graphics 1280, 800, 16, 2
SetBuffer BackBuffer()
ClsColor 50,20,20

;Konstanten 
Const LOOSE=0
Const WIN=1
Const AGAIN=2
Const NEWONE=3

;ObjektTypes

Type waypoint
	Field id
	Field image
	Field x, y
End Type 

Global waypointimage=LoadImage("waypoint.bmp")
MaskImage waypointimage, 255, 0, 255
MidHandle(waypointimage)


Type lampe
	Field image
	Field x, y 
	Field status
	Field lightimage
End Type 

Global lampeimage=LoadImage("lampe.png")
MaskImage lampeimage, 255, 0, 255
MidHandle(lampeimage)

Global light=LoadImage("light.png")
MaskImage light, 255, 0, 255
MidHandle(light)


Type enemy
	Field image
	Field x, y 
	Field startx, starty
	Field zielx, ziely
	Field speed
	Field direction
End Type

Global enemyimage=LoadImage("enemy.png")
MaskImage enemyimage, 255, 0, 255
MidHandle (enemyimage)


;Nur eine Spielfigur--> keine Types(spart Zeit ;) )
Global Spielerx, Spielery, Spielerimage=LoadImage("prisoner.bmp"), spielerspeed=3
MaskImage Spielerimage, 255, 0, 255
MidHandle(Spielerimage)


;Array, welcher die Namen der Level speichert
Dim levels$(20)

;einige Variablen
Global aktuellerwaypoint, move=True , aktuelleslevel=0, waypointcounter, aktfile 
;Hintergrund laden
Global bg=LoadImage("hintergrund.png")

font=LoadFont("Arial", 18)
SetFont font


maintimer=CreateTimer(60)

getleveldata(); Speicherung der Level
Readobjects(levels(aktuelleslevel))

While Not(KeyDown(1))
Cls
	
	If KeyHit(19) Then reset(AGAIN)
	bar()
	lamplight()
	drawobjects()
	
	moveplayer()
	moveenemys()
	collide()
	
	
	
	WaitTimer(maintimer)

Flip(0)
Wend  
End 




Function drawobjects()
	
	For l.lampe=Each lampe
		DrawImage l\image, l\x, l\y
			
	Next 
	
	For w.waypoint=Each waypoint
		Text w\x-5, w\y-30, w\id+1
		DrawImage w\image, w\x, w\y
		
	Next 
	
	DrawImage Spielerimage, spielerx, spielery
	
	For e.enemy=Each enemy
		DrawImage e\image, e\x, e\y
	Next
	
	
	
	 	
End Function




Function moveplayer() 

For l.lampe= Each lampe
		If ImagesOverlap(spielerimage, spielerx, spielery, l\lightimage, l\x, l\y+75) And l\status=1
			move=False:Exit 
		Else 
			move=True 
		EndIf 
		
Next 

If move=True
For w.waypoint=Each waypoint

	  
	If w\id=aktuellerwaypoint 
			
			If w\y<spielery Then 
				spielery=spielery-spielerspeed
			ElseIf w\y>spielery 
				spielery=spielery+spielerspeed
			EndIf 
		
			If w\x<spielerx Then 
				spielerx=spielerx-spielerspeed
			ElseIf w\x>spielerx 
				spielerx=spielerx+spielerspeed
			EndIf 		
			
		
		
		If w\x<spielerx+3 And w\x>spielerx-3 And w\y>spielery-3 And w\y<spielery+3 Then 
			aktuellerwaypoint=aktuellerwaypoint+1
			If aktuellerwaypoint>=waypointcounter Then ende(WIN)	
		EndIf 
	EndIf 
	 

Next  
EndIf 

End Function

Function moveenemys()
	For e.enemy=Each enemy
		Select e\direction 
			Case 0
				If e\y<e\ziely Then 
					e\y=e\y+e\speed
				ElseIf e\y>e\ziely 
					e\y=e\y-e\speed
				EndIf 
		
				If e\x<e\zielx Then 
					e\x=e\x+e\speed
				ElseIf e\x>e\zielx 
					e\x=e\x-e\speed
				EndIf
				 	
			Case 1
				If e\y<e\starty Then 
					e\y=e\y+e\speed
				ElseIf e\y>e\starty 
					e\y=e\y-e\speed
				EndIf 
		
				If e\x<e\startx Then 
					e\x=e\x+e\speed
				ElseIf e\x>e\startx 
					e\x=e\x-e\speed
				EndIf
				
		End Select

	If(e\x=e\startx And e\y=e\starty) Or (e\y=e\ziely And e\x=e\zielx) 
		e\direction=1-e\direction
	EndIf 
	
	
	Next 
End Function 

Function collide()
	For e.enemy=Each enemy 
		If ImagesOverlap(spielerimage, spielerx, spielery, e\image, e\x, e\y) Then 
			ende(LOOSE)
		EndIf 
	Next 
End Function 


Function lamplight()
	mh=MouseHit(1)
	mx=MouseX()
	my=MouseY()
	
	For l.lampe=Each lampe
		If mx>l\x-40 And mx<l\x+40 And my>l\y-30 And my<l\y+30 Then 
			If mh Then 
				l\status=1-l\status
			EndIf 
		EndIf 
		
		If l\status=1 Then 
			DrawImage l\lightimage, l\x, l\y+75			
		EndIf 
	Next
	
End Function 





Function Readobjects(file$)
	
	
	Local waypointID
	
	level=OpenFile(file)
	If level=0 Then Print "Dieser Ordner enthlt keine Level":WaitKey():getleveldata() 
	
	
	While Not(Eof(level))
		objekt$=ReadLine(level) ; Herausfinden, welches Objekt und dann in entsprechenden Type speichern
		
		Select objekt 
			Case "Spielfigur"
				Spielerx=ReadLine(level)
				Spielery=ReadLine(level)
			Case "Lampe"
				l.lampe=New lampe
				l\image=lampeimage
				l\x=ReadLine(level)
				l\y=ReadLine(level)
				l\status=ReadLine(level)
				l\lightimage=light 
			Case "Waypoint"
				w.waypoint=New waypoint
				w\image=waypointimage
				w\x=ReadLine(level)
				w\y=ReadLine(level)
				w\id=waypointid
				waypointID=waypointid+1
				waypointcounter=waypointID
			Case "Enemy"
				e.enemy=New enemy
				e\image=enemyimage
				e\startx=ReadLine(level)
				e\starty=ReadLine(level)
				e\zielx=ReadLine(level)
				e\ziely=ReadLine(level)
				e\speed=ReadLine(level)
				e\direction=0
				e\x=e\startx
				e\y=e\starty
		End Select 
						
	Wend 
	CloseFile(level)
End Function



Function reset(stat)
	Color 0,255,0
	For l.lampe=Each lampe
			l\status=0
			Delete l.lampe
		Next
	For e.enemy= Each enemy 
		Delete e.enemy
	Next
	
	For w.waypoint=Each waypoint
		Delete w.waypoint
	Next 
		
	aktuellerwaypoint=0
	waypointcounter=0
	
	Select stat
		Case NEWONE
			aktuelleslevel=aktuelleslevel+1
			If aktfile=aktuelleslevel Then Cls:Print "Levelpaket beendet...Neues Pack laden?":WaitKey():aktuelleslevel=0:Getleveldata()
			readobjects(levels(aktuelleslevel))
		Case AGAIN				
			readobjects(levels(aktuelleslevel))		
	End Select 

End Function 

Function ende(stat)
	Color 0,0,0
	Select stat
		Case LOOSE 
			bar()			
			Text 500, 300, "Sie wurden entdeckt!"
			Text 450, 350, "Drcken sie eine Taste um erneut zu spielen"
			Flip(0)
			WaitKey()
			reset(AGAIN)
		Case WIN
			bar()		
			Text 500, 300, "Sie sind entkommen!"
			Text 450, 350, "Drcken sie eine Taste um zum nchsten Level zu gelangen"
			Flip(0)
			WaitKey()
			reset(NEWONE)
	End Select
End Function  
	
Function getleveldata()
	Color 0,255,0
	aktfile=0
	Print "Welches Levelpaket wollen Sie spielen?"
	Print "Levelpakete zur Auswahl: "
	thefolder=ReadDir(".")

	Repeat 		
		all$=NextFile$(thefolder) 
			
		If all$="" Then Exit 
			
		If FileType(CurrentDir$()+all$)=2
			Print  all$ 	
		EndIf 
	Forever 
	 
	
	foldername$=Input("Levelpaket: ")
	folder=ReadDir(foldername$)

		
	file$=NextFile$(folder)
	file$=NextFile$(folder)
	
	Repeat  		
		file$=NextFile$(folder)
		If file$="" Then Exit
		levels(aktfile)=foldername+"\"+file$						
		aktfile=aktfile+1		
		aktuelleslevel=0
	Forever  	


End Function 

Function bar()
	Color 0,255,0
	Line 0, 150, 1280, 150
	Text 75, 75, "Aktuelles Level: "+ levels(aktuelleslevel)	
	DrawImage bg, 0, 150
	Color 0,0,0
End Function 





















	